Loading...
Searching...
No Matches
FGRealWorldValueMapping::RWVMItem Class Reference

Class representing the Real World Value Mapping Item Macro: Attribute name: (VR, VM, Requirement Type) Real World Value First Value Mapped: (US or SS, 1, 1) Real World Value Last Value Mapped: (US or SS, 1, 1) Real World Value Intercept: (FD, 1, 1C) Real World Value Slope: (FD, 1, 1C) Real World Value LUT Data (FD, 1-n, 1C) LUT Explanation (LO, 1, 1) LUT Label (SH, 1, 1) Measurement Units Code Sequence (SQ, 1, 1) Quantity Definition Sequence (SQ, 1, 3). More...

Inheritance diagram for FGRealWorldValueMapping::RWVMItem:

## Public Member Functions

| RWVMItem (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor.
| RWVMItem (IODComponent *parent=NULL)
| Constructor.
| RWVMItem (const RWVMItem &rhs)
| Copy Constructor.
RWVMItem * | clone ()
| Clone this class (perform deep copy).
virtual | ~RWVMItem ()
| Virtual destructor, frees memory.
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of component.
virtual int | compare (const IODComponent &rhs) const
| Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read attributes from given item into this class.
virtual OFCondition | write (DcmItem &destination)
| Write attributes from this class into given item.
virtual OFCondition | getRealWorldValueFirstValueMapped (Sint32 &value, const unsigned long pos=0) const
| Get Real World Value First Value Mapped.
virtual OFCondition | getRealWorldValueLastValueMapped (Sint32 &value, const unsigned long pos=0) const
| Get Real World Value First Value Mapped.
virtual OFCondition | getDoubleFloatRealWorldValueFirstValueMapped (Float64 &value, const unsigned long pos=0) const
| Get Double Float Real World Value First Value Mapped.
virtual OFCondition | getDoubleFloatRealWorldValueLastValueMapped (Float64 &value, const unsigned long pos=0) const
| Get Double Float Real World Value Last Value Mapped.
virtual OFCondition | getRealWorldValueLUTData (Float64 &value, const unsigned long pos=0) const
| Get Real World Value LUT Data.
virtual OFCondition | getRealWorldValueLUTData (OFVector< Float64 > &values) const
| Get Real World Value LUT Data.
virtual OFCondition | getLUTExplanation (OFString &value, const signed long pos=0) const
| Get LUT Explanation.
virtual OFCondition | getLUTLabel (OFString &value, const signed long pos=0) const
| Get LUT Label.
virtual CodeSequenceMacro & | getMeasurementUnitsCode ()
| Get Measurement Units Code Sequence (content).
virtual OFVector< ContentItemMacro * > & | getEntireQuantityDefinitionSequence ()
| Get a reference to the entire ConceptNameCodeSequence, including items exceeding the value multiplicity restriction of "1".
virtual OFCondition | setRealWorldValueFirstValueMappedUnsigned (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Real World Value First Value Mapped.
virtual OFCondition | setRealWorldValueFirstValueMappedSigned (const Sint16 &value, const OFBool checkValue=OFTrue)
| Set Real World Value First Value Mapped.
virtual OFCondition | setRealWorldValueLastValueMappedUnsigned (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Real World Value Last Value Mapped.
virtual OFCondition | setRealWorldValueLastValueMappedSigned (const Sint16 &value, const OFBool checkValue=OFTrue)
| Set Real World Value Last Value Mapped.
virtual OFCondition | setDoubleFloatRealWorldValueFirstValueMapped (const Float64 value, const OFBool checkValue=OFTrue)
| Set Double Float Real World Value First Value Mapped.
virtual OFCondition | setDoubleFloatRealWorldValueLastValueMapped (const Float64 value, const OFBool checkValue=OFTrue)
| Set Double Float Real World Value Last Value Mapped.
virtual OFCondition | setRealWorldValueIntercept (const Float64 value, const OFBool checkValue=OFTrue)
| Set Real World Value Intercept.
virtual OFCondition | setRealWorldValueSlope (const Float64 value, const OFBool checkValue=OFTrue)
| Set Real World Value Slope.
virtual OFCondition | setRealWorldValueLUTData (const OFVector< Float64 > &value, const OFBool checkValue=OFTrue)
| Set Real World Value LUT Data.
virtual OFCondition | setLUTExplanation (const OFString &value, const OFBool checkValue=OFTrue)
| Set LUT Explanation.
virtual OFCondition | setLUTLabel (const OFString &value, const OFBool checkValue=OFTrue)
| Set LUT Label.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor.
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch.
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set.
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set.
virtual | ~IODComponent ()
| Virtual Destructor.
virtual void | clearData ()
| Clear all attributes from the data that are handled by this module.
virtual void | inventMissing ()
| Set missing values by inventing "default values".
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module.
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3.
DcmItem & | getData ()
| Get the data handled by this module.
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules.
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing.
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e.

## Private Attributes

CodeSequenceMacro | m_MeasurementUnitsCode
| Measurement Units Code Sequence.
OFVector< ContentItemMacro * > | m_QuantityDefinitionSequence
| Quantity Definition Sequence.

## Static Private Attributes

static const OFString | m_ModuleName
| The name of this module ("RealWorldValueMappingItemMacro").

## Additional Inherited Members

Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name.
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name.
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class.
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e.

## Detailed Description

Class representing the Real World Value Mapping Item Macro: Attribute name: (VR, VM, Requirement Type) Real World Value First Value Mapped: (US or SS, 1, 1) Real World Value Last Value Mapped: (US or SS, 1, 1) Real World Value Intercept: (FD, 1, 1C) Real World Value Slope: (FD, 1, 1C) Real World Value LUT Data (FD, 1-n, 1C) LUT Explanation (LO, 1, 1) LUT Label (SH, 1, 1) Measurement Units Code Sequence (SQ, 1, 1) Quantity Definition Sequence (SQ, 1, 3).

## Constructor & Destructor Documentation

## RWVMItem() [1/3]

FGRealWorldValueMapping::RWVMItem::RWVMItem | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules,
|  | IODComponent * | parent = NULL )

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.
  parent | The parent of the IOD component (NULL if none or unknown)

References IODComponent::IODComponent().

Referenced by RWVMItem(), and clone().

## RWVMItem() [2/3]

FGRealWorldValueMapping::RWVMItem::RWVMItem | ( | IODComponent * | parent = NULL | ) |

Constructor.

Parameters

  parent | The parent of the IOD component (NULL if none or unknown)

References IODComponent::IODComponent().

## RWVMItem() [3/3]

FGRealWorldValueMapping::RWVMItem::RWVMItem | ( | const RWVMItem & | rhs | ) |

Copy Constructor.

Parameters

  rhs | The item to copy from

References RWVMItem().

## Member Function Documentation

## clone()

RWVMItem * FGRealWorldValueMapping::RWVMItem::clone | ( |  | ) |

Clone this class (perform deep copy).

Returns
  Clone of this class or NULL (e.g. if memory exhausted)

References RWVMItem().

## compare()

virtual int FGRealWorldValueMapping::RWVMItem::compare | ( | const IODComponent & | rhs | ) | const

virtual

Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!

Both objects (this and rhs) need to have the same type (i.e. both FGUnknown) to be comparable. This function is used in order to decide whether a functional group already exists, or is new. This is used in particular to find out whether a given functional group can be shared (i.e. the same information already exists as shared functional group) or is different from the same shared group. In that case the shared functional group must be distributed into per-frame functional groups, instead. The exact implementation for implementing the comparison is not relevant. However, it must be a comparison by value.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if either the value of the first component that does not match is lower in the this object, or all compared components match but this component is shorter. Also returned if this type and rhs type (DcmFGTypes::E_FGType) do not match. 1 if either the value of the first component that does not match is greater in this object, or all compared components match but this component is longer.

Reimplemented from IODComponent.

References IODComponent::IODComponent().

## getDoubleFloatRealWorldValueFirstValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getDoubleFloatRealWorldValueFirstValueMapped | ( | Float64 & | value,
|  | const unsigned long | pos = 0 ) const

virtual

Get Double Float Real World Value First Value Mapped.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getDoubleFloatRealWorldValueLastValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getDoubleFloatRealWorldValueLastValueMapped | ( | Float64 & | value,
|  | const unsigned long | pos = 0 ) const

virtual

Get Double Float Real World Value Last Value Mapped.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getEntireQuantityDefinitionSequence()

virtual OFVector< ContentItemMacro * > & FGRealWorldValueMapping::RWVMItem::getEntireQuantityDefinitionSequence | ( |  | ) |

virtual

Get a reference to the entire ConceptNameCodeSequence, including items exceeding the value multiplicity restriction of "1".

Returns
  a reference to the entire ConceptNameCodeSequence

## getLUTExplanation()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getLUTExplanation | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

Get LUT Explanation.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getLUTLabel()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getLUTLabel | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

Get LUT Label.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getMeasurementUnitsCode()

virtual CodeSequenceMacro & FGRealWorldValueMapping::RWVMItem::getMeasurementUnitsCode | ( |  | ) |

virtual

Get Measurement Units Code Sequence (content).

Returns
  Reference to Measurement Units Code

## getName()

virtual OFString FGRealWorldValueMapping::RWVMItem::getName | ( |  | ) | const

virtual

Get name of component.

Returns
  Name of the module

Implements IODComponent.

## getRealWorldValueFirstValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getRealWorldValueFirstValueMapped | ( | Sint32 & | value,
|  | const unsigned long | pos = 0 ) const

virtual

Get Real World Value First Value Mapped.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getRealWorldValueLastValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getRealWorldValueLastValueMapped | ( | Sint32 & | value,
|  | const unsigned long | pos = 0 ) const

virtual

Get Real World Value First Value Mapped.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getRealWorldValueLUTData() [1/2]

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getRealWorldValueLUTData | ( | Float64 & | value,
|  | const unsigned long | pos = 0 ) const

virtual

Get Real World Value LUT Data.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## getRealWorldValueLUTData() [2/2]

virtual OFCondition FGRealWorldValueMapping::RWVMItem::getRealWorldValueLUTData | ( | OFVector< Float64 > & | values | ) | const

virtual

Get Real World Value LUT Data.

Parameters

  values | Reference to variable in which the values should be stored

Returns
  EC_Normal if successful, an error code otherwise

## read()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::read | ( | DcmItem & | source,
|  | const OFBool | clearOldData = OFTrue )

virtual

Read attributes from given item into this class.

Parameters

  source | The source to read from
  clearOldData | If OFTrue, old data is cleared before reading. Otherwise old data is overwritten (or amended)

Returns
  EC_Normal if reading was successful, error otherwise

Reimplemented from IODComponent.

## setDoubleFloatRealWorldValueFirstValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setDoubleFloatRealWorldValueFirstValueMapped | ( | const Float64 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Double Float Real World Value First Value Mapped.

Parameters

  value | Value to be set
  checkValue | Check 'value'. Does nothing, only for consistency with other set() functions.

Returns
  EC_Normal if successful, an error code otherwise

## setDoubleFloatRealWorldValueLastValueMapped()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setDoubleFloatRealWorldValueLastValueMapped | ( | const Float64 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Double Float Real World Value Last Value Mapped.

Parameters

  value | Value to be set
  checkValue | Check 'value'. Does nothing, only for consistency with other set() functions.

Returns
  EC_Normal if successful, an error code otherwise

## setLUTExplanation()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setLUTExplanation | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set LUT Explanation.

Parameters

  value | Value to be set
  checkValue | Check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## setLUTLabel()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setLUTLabel | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set LUT Label.

Parameters

  value | Value to be set
  checkValue | Check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueFirstValueMappedSigned()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueFirstValueMappedSigned | ( | const Sint16 & | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value First Value Mapped.

Parameters

  value | Value to be set. If Pixel Representation is -1 (signed pixel data) value must be -2^15 < value < 2^15-1. Otherwise use setRealWorldValueFirstValueMappedUnsigned().
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueFirstValueMappedUnsigned()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueFirstValueMappedUnsigned | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value First Value Mapped.

Parameters

  value | Value to be set. If Pixel Representation is 0 (unsigned pixel data) value must be 0 < value < 2^16. Otherwise use setRealWorldValueFirstValueMappedSigned().
  checkValue | Check 'value' for conformance with VR (US and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueIntercept()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueIntercept | ( | const Float64 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value Intercept.

Parameters

  value | Value to be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueLastValueMappedSigned()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueLastValueMappedSigned | ( | const Sint16 & | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value Last Value Mapped.

Parameters

  value | Value to be set. If Pixel Representation is -1 (signed pixel data) value must be -2^15 < value < 2^15-1. Otherwise use setRealWorldValueLastValueMappedUnsigned().
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueLastValueMappedUnsigned()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueLastValueMappedUnsigned | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value Last Value Mapped.

Parameters

  value | Value to be set. If Pixel Representation is 0 (unsigned pixel data) value must be 0 < value < 2^16. Otherwise use setRealWorldValueLastValueMappedSigned().
  checkValue | Check 'value' for conformance with VR (US and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueLUTData()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueLUTData | ( | const OFVector< Float64 > & | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value LUT Data.

Parameters

  value | Values to be set
  checkValue | Check 'value' for conformance with VR (FD) and VM (1-n) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## setRealWorldValueSlope()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::setRealWorldValueSlope | ( | const Float64 | value,
|  | const OFBool | checkValue = OFTrue )

virtual

Set Real World Value Slope.

Parameters

  value | Value to be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## write()

virtual OFCondition FGRealWorldValueMapping::RWVMItem::write | ( | DcmItem & | destination | ) |

virtual

Write attributes from this class into given item.

Parameters

  destination | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Reimplemented from IODComponent.

The documentation for this class was generated from the following file:

- dcmfg/include/dcmtk/dcmfg/fgrealworldvaluemapping.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0